"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _vue = require("vue");
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classNames5 = _interopRequireDefault(require("../_util/classNames"));
var _FormItemContext = require("../form/FormItemContext");
var _useConfigInject2 = _interopRequireDefault(require("../_util/hooks/useConfigInject"));
var _statusUtils = require("../_util/statusUtils");
var _commonUtils = require("../vc-input/utils/commonUtils");
var _Input = _interopRequireDefault(require("../vc-input/Input"));
var _inputProps = _interopRequireDefault(require("./inputProps"));
var _omit = _interopRequireDefault(require("../_util/omit"));
var _CloseCircleFilled = _interopRequireDefault(require("@ant-design/icons-vue/lib/icons/CloseCircleFilled"));
var _excluded = ["allowClear", "bordered", "prefix", "suffix", "addonAfter", "addonBefore", "id"];
var _default2 = (0, _vue.defineComponent)({
  compatConfig: {
    MODE: 3
  },
  name: 'AInput',
  inheritAttrs: false,
  props: (0, _inputProps.default)(),
  setup: function setup(props, _ref) {
    var slots = _ref.slots,
      attrs = _ref.attrs,
      expose = _ref.expose,
      emit = _ref.emit;
    var inputRef = (0, _vue.ref)();
    var formItemContext = (0, _FormItemContext.useInjectFormItemContext)();
    var formItemInputContext = _FormItemContext.FormItemInputContext.useInject();
    var mergedStatus = (0, _vue.computed)(function () {
      return (0, _statusUtils.getMergedStatus)(formItemInputContext.status, props.status);
    });
    var _useConfigInject = (0, _useConfigInject2.default)('input', props),
      direction = _useConfigInject.direction,
      prefixCls = _useConfigInject.prefixCls,
      size = _useConfigInject.size,
      autocomplete = _useConfigInject.autocomplete;
    var focus = function focus(option) {
      var _inputRef$value;
      (_inputRef$value = inputRef.value) === null || _inputRef$value === void 0 ? void 0 : _inputRef$value.focus(option);
    };
    var blur = function blur() {
      var _inputRef$value2;
      (_inputRef$value2 = inputRef.value) === null || _inputRef$value2 === void 0 ? void 0 : _inputRef$value2.blur();
    };
    var setSelectionRange = function setSelectionRange(start, end, direction) {
      var _inputRef$value3;
      (_inputRef$value3 = inputRef.value) === null || _inputRef$value3 === void 0 ? void 0 : _inputRef$value3.setSelectionRange(start, end, direction);
    };
    var select = function select() {
      var _inputRef$value4;
      (_inputRef$value4 = inputRef.value) === null || _inputRef$value4 === void 0 ? void 0 : _inputRef$value4.select();
    };
    expose({
      focus: focus,
      blur: blur,
      input: inputRef,
      setSelectionRange: setSelectionRange,
      select: select
    });
    // ===================== Remove Password value =====================
    var removePasswordTimeoutRef = (0, _vue.ref)([]);
    var removePasswordTimeout = function removePasswordTimeout() {
      removePasswordTimeoutRef.value.push(setTimeout(function () {
        var _inputRef$value5, _inputRef$value6, _inputRef$value7;
        if ((_inputRef$value5 = inputRef.value) !== null && _inputRef$value5 !== void 0 && _inputRef$value5.input && ((_inputRef$value6 = inputRef.value) === null || _inputRef$value6 === void 0 ? void 0 : _inputRef$value6.input.getAttribute('type')) === 'password' && (_inputRef$value7 = inputRef.value) !== null && _inputRef$value7 !== void 0 && _inputRef$value7.input.hasAttribute('value')) {
          var _inputRef$value8;
          (_inputRef$value8 = inputRef.value) === null || _inputRef$value8 === void 0 ? void 0 : _inputRef$value8.input.removeAttribute('value');
        }
      }));
    };
    (0, _vue.onMounted)(function () {
      removePasswordTimeout();
    });
    (0, _vue.onBeforeUpdate)(function () {
      removePasswordTimeoutRef.value.forEach(function (item) {
        return clearTimeout(item);
      });
    });
    (0, _vue.onBeforeUnmount)(function () {
      removePasswordTimeoutRef.value.forEach(function (item) {
        return clearTimeout(item);
      });
    });
    var handleBlur = function handleBlur(e) {
      removePasswordTimeout();
      emit('blur', e);
      formItemContext.onFieldBlur();
    };
    var handleFocus = function handleFocus(e) {
      removePasswordTimeout();
      emit('focus', e);
    };
    var triggerChange = function triggerChange(e) {
      emit('update:value', e.target.value);
      emit('change', e);
      emit('input', e);
      formItemContext.onFieldChange();
    };
    return function () {
      var _slots$prefix, _slots$suffix, _slots$addonAfter, _slots$addonBefore, _formItemContext$id, _classNames, _classNames2, _classNames4;
      var hasFeedback = formItemInputContext.hasFeedback,
        feedbackIcon = formItemInputContext.feedbackIcon;
      var allowClear = props.allowClear,
        _props$bordered = props.bordered,
        bordered = _props$bordered === void 0 ? true : _props$bordered,
        _props$prefix = props.prefix,
        prefix = _props$prefix === void 0 ? (_slots$prefix = slots.prefix) === null || _slots$prefix === void 0 ? void 0 : _slots$prefix.call(slots) : _props$prefix,
        _props$suffix = props.suffix,
        suffix = _props$suffix === void 0 ? (_slots$suffix = slots.suffix) === null || _slots$suffix === void 0 ? void 0 : _slots$suffix.call(slots) : _props$suffix,
        _props$addonAfter = props.addonAfter,
        addonAfter = _props$addonAfter === void 0 ? (_slots$addonAfter = slots.addonAfter) === null || _slots$addonAfter === void 0 ? void 0 : _slots$addonAfter.call(slots) : _props$addonAfter,
        _props$addonBefore = props.addonBefore,
        addonBefore = _props$addonBefore === void 0 ? (_slots$addonBefore = slots.addonBefore) === null || _slots$addonBefore === void 0 ? void 0 : _slots$addonBefore.call(slots) : _props$addonBefore,
        _props$id = props.id,
        id = _props$id === void 0 ? (_formItemContext$id = formItemContext.id) === null || _formItemContext$id === void 0 ? void 0 : _formItemContext$id.value : _props$id,
        rest = (0, _objectWithoutProperties2.default)(props, _excluded);
      var suffixNode = (hasFeedback || suffix) && (0, _vue.createVNode)(_vue.Fragment, null, [suffix, hasFeedback && feedbackIcon]);
      var prefixClsValue = prefixCls.value;
      var inputHasPrefixSuffix = (0, _commonUtils.hasPrefixSuffix)({
        prefix: prefix,
        suffix: suffix
      }) || !!hasFeedback;
      var clearIcon = slots.clearIcon || function () {
        return (0, _vue.createVNode)(_CloseCircleFilled.default, null, null);
      };
      return (0, _vue.createVNode)(_Input.default, (0, _objectSpread2.default)((0, _objectSpread2.default)((0, _objectSpread2.default)({}, attrs), (0, _omit.default)(rest, ['onUpdate:value', 'onChange', 'onInput'])), {}, {
        "onChange": triggerChange,
        "id": id,
        "ref": inputRef,
        "prefixCls": prefixClsValue,
        "autocomplete": autocomplete.value,
        "onBlur": handleBlur,
        "onFocus": handleFocus,
        "suffix": suffixNode,
        "allowClear": allowClear,
        "addonAfter": addonAfter && (0, _vue.createVNode)(_FormItemContext.NoFormStatus, null, {
          default: function _default() {
            return [addonAfter];
          }
        }),
        "addonBefore": addonBefore && (0, _vue.createVNode)(_FormItemContext.NoFormStatus, null, {
          default: function _default() {
            return [addonBefore];
          }
        }),
        "inputClassName": (0, _classNames5.default)((_classNames = {}, (0, _defineProperty2.default)(_classNames, "".concat(prefixClsValue, "-sm"), size.value === 'small'), (0, _defineProperty2.default)(_classNames, "".concat(prefixClsValue, "-lg"), size.value === 'large'), (0, _defineProperty2.default)(_classNames, "".concat(prefixClsValue, "-rtl"), direction.value === 'rtl'), (0, _defineProperty2.default)(_classNames, "".concat(prefixClsValue, "-borderless"), !bordered), _classNames), !inputHasPrefixSuffix && (0, _statusUtils.getStatusClassNames)(prefixClsValue, mergedStatus.value)),
        "affixWrapperClassName": (0, _classNames5.default)((_classNames2 = {}, (0, _defineProperty2.default)(_classNames2, "".concat(prefixClsValue, "-affix-wrapper-sm"), size.value === 'small'), (0, _defineProperty2.default)(_classNames2, "".concat(prefixClsValue, "-affix-wrapper-lg"), size.value === 'large'), (0, _defineProperty2.default)(_classNames2, "".concat(prefixClsValue, "-affix-wrapper-rtl"), direction.value === 'rtl'), (0, _defineProperty2.default)(_classNames2, "".concat(prefixClsValue, "-affix-wrapper-borderless"), !bordered), _classNames2), (0, _statusUtils.getStatusClassNames)("".concat(prefixClsValue, "-affix-wrapper"), mergedStatus.value, hasFeedback)),
        "wrapperClassName": (0, _classNames5.default)((0, _defineProperty2.default)({}, "".concat(prefixClsValue, "-group-rtl"), direction.value === 'rtl')),
        "groupClassName": (0, _classNames5.default)((_classNames4 = {}, (0, _defineProperty2.default)(_classNames4, "".concat(prefixClsValue, "-group-wrapper-sm"), size.value === 'small'), (0, _defineProperty2.default)(_classNames4, "".concat(prefixClsValue, "-group-wrapper-lg"), size.value === 'large'), (0, _defineProperty2.default)(_classNames4, "".concat(prefixClsValue, "-group-wrapper-rtl"), direction.value === 'rtl'), _classNames4), (0, _statusUtils.getStatusClassNames)("".concat(prefixClsValue, "-group-wrapper"), mergedStatus.value, hasFeedback))
      }), (0, _objectSpread2.default)((0, _objectSpread2.default)({}, slots), {}, {
        clearIcon: clearIcon
      }));
    };
  }
});
exports.default = _default2;